# Microeconometrics
# CLASS 2c
# Intervally censored variable
# Wiktor Budzinski, Marek Giergiczny

rm(list=ls())

library(readxl)
library(survival)

setwd("C:\\Users\\budzi\\Documents\\ME QPE\\2023\\Class 2") 

data <- read_excel("WTPint.xls")
data[data[,2]  > 1200,2] <- Inf

data$eventX <- rep(3, nrow(data)) # how the variable is censored
data$eventX[data[,1] == 1200] <- 0 #from 1 side

data$Y <- Surv(data$WTP_low, data$WTP_up, event = data$eventX, type = "interval")
Eq1 <- Y ~ H2 + H4 + H8 + Age22 + Age45 + Age65 + Female + Income + Edu2 + Edu3 + Edu4
m1 <- survreg(Eq1, data = data, dist = "gaussian")
summary(m1)


m2 <- survreg(Eq1, data = data, dist = "lognormal")

data$WTP_low[data$WTP_low == 0]<- 0.001
data$Y2 <- Surv(data$WTP_low, data$WTP_up, event = data$eventX, type = "interval")
Eq2 <- Y2 ~ H2 + H4 + H8 + Age22 + Age45 + Age65 + Female + Income + Edu2 + Edu3 + Edu4
m2 <- survreg(Eq2, data = data, dist = "lognormal")
summary(m2)

m3 <- survreg(Eq2, data = data, dist = "weibull")
summary(m3)

